<?

class chart {
 
 
 
 
 var $data=array();
 
 var $color=array();
 
 var $label=array();
 
 var $x_size = 500;
 var $y_size = 250;
 
 var $x_title;
 var $y_title;
 var $z_title;
 
 var $left_margin = 50;
 var $right_margin = 20;
 var $top_margin = 20;
 var $bottom_margin = 60;
 
 var $nr_values;
 
 var $col_back = 'ffffff';
 
 var $col_grid = '000000';
 
 var $col_chart = 'ff0000';
 
 var $col_font = '000000';
 
 
 var $first_islabel = true;
 
 var $show_values = true;
 
 var $decimals = 2;
 
 var $grid_decimals = 2;
 
 var $draw_type = "wireframe";
 
 var $render_type = "ISO";
 
 var $transparent = 0;

 

 
 var $x_tot_margin;
 var $y_tot_margin;
 
 var $small_font = 2;
 var $small_font_width = 6;
 var $small_font_height = 10;
 var $tiny_font = 3;
 
 var $grid=array();
 var $grid_x_size=0;
 var $grid_z_size=0;
 var $grid_max_y=0;
 var $grid_min_y=0;
 var $grid_x_label=array();
 var $grid_z_label=array();

 var $x_rotate=0;
 var $y_rotate=0;
 var $z_rotate=0;

 var $graph;

 var $graph_min_x;
 var $graph_max_x;
 var $graph_min_y;
 var $graph_max_y;
 var $graph_min_z;
 var $graph_max_z;

 var $render;

 
 function chart ($d) {

 
 $this->data = $d;

 $this->get_grid_data();

 }

 
 function get_grid_data() {
 
 $this->error_check();
 
 
 if (!is_array($this->data)) { $this->error = "data has wrong format."; return true; }
 
 $this->grid = array();
 $this->grid_x_size = 0;
 $this->grid_z_size = 0;
 $this->grid_max_y = 0;
 $this->grid_min_y = 0;
 $this->grid_x_label = array();
 $this->grid_z_label = array();
 
 reset($this->data);
 $this->grid_x_size = count($this->data);
 while (list($key,$val) = each($this->data)) {
 $i = (is_array($val))?count($val):1;
 if ($this->first_islabel) $i--;
 $this->grid_z_size = max($this->grid_z_size,$i);
 }
 
 reset($this->data);
 $row = array();
 for ($j = 0; $j < $this->grid_z_size; $j++) {
 $row[$j] = array("val"=>0,"label"=>"","color"=>$this->col_chart);
 $this->grid_z_label[$j] = $this->label[$j];
 }
 for ($j = 0; $j < $this->grid_x_size; $j++) {
 $this->grid[$j] = $row;
 for ($i = 0; $i < $this->grid_z_size; $i++) {
 if (is_array($this->color[$i]) && $this->color[$i][$j]) {
 $this->grid[$j][$i]["color"] = $this->color[$i][$j];
 } else if (isset($this->color[$i]) && !is_array($this->color[$i])) {
 $this->grid[$j][$i]["color"] = $this->color[$i];
 }
 }
 }
 
 $i=0;
 reset($this->data);
 while (list($key,$val) = each($this->data)) {
 $j = 0;
 if (!is_array($val)) $val = array($val);
 reset($val);
 if ($this->first_islabel) {
 list($k,$v) = each($val);
 $this->grid_x_label[$i] = $v;
 }
 while (list($k,$v) = each($val)) {
 if (!is_numeric($k)) $this->grid[$i][$j]["label"] = $k;
 $this->grid[$i][$j]["val"] = $v;
 if ($v < 0) {
 $this->grid_min_y = min($this->grid_min_y, $v);
 } else {
 $this->grid_max_y = max($this->grid_max_y, $v);
 }
 $j++;
 }
 
 $i++;
 }

 }

 function init_3D() {
 
 if ($this->render_type == "ISO") {
 
 $this->render = new renderISO($this->graph, $this->left_margin, $this->top_margin, $this->x_size - $this->left_margin - $this->right_margin, $this->y_size - $this->top_margin - $this->bottom_margin, $this->col_font, $this->draw_type);
 $this->render->init_3D($this->graph_min_x,$this->graph_max_x, $this->graph_min_y,$this->graph_max_y,$this->graph_min_z,$this->max_z);
 
 } else if ($this->render_type == "perspective") {

 $this->render = new renderPerspective($this->graph, $this->left_margin, $this->top_margin, $this->x_size - $this->left_margin - $this->right_margin, $this->y_size - $this->top_margin - $this->bottom_margin, $this->col_font, $this->draw_type);
 $this->render->init_3D($this->graph_min_x,$this->graph_max_x, $this->graph_min_y,$this->graph_max_y,$this->graph_min_z,$this->max_z);
 $this->render->init_Viewpoint(1,$this->x_rotate,$this->y_rotate,$this->z_rotate,$this->transparent); 
 }

 }

 function draw_text($txt,$x,$y,$z,$rotation=0,$alignment="topleft",$color="") {
 $this->render->draw_text($txt,$x,$y,$z,$rotation,$alignment,$color);
 }

 function draw_line($x1,$y1,$z1,$x2,$y2,$z2,$color='000000') {
 $this->render->draw_line($x1,$y1,$z1,$x2,$y2,$z2,$color);
 }

 function draw_poly($vertices,$color='000000') {
 $this->render->draw_poly($vertices,$color);
 }

 function draw_filledpoly($vertices,$color='000000') {
 $this->render->draw_filledpoly($vertices,$color);
 }

 function draw_cube($x,$y,$z,$height,$depth,$width,$color='ff0000',$draw_type="") {
 $this->render->draw_cube($x,$y,$z,$height,$depth,$width,$color,$draw_type);
 }

 function draw_prism() {
 $this->render->draw_prism();
 }

 function init_image() {
 $this->graph = ImageCreate($this->x_size, $this->y_size);
 $background_color = ImageColorAllocate ($this->graph, 255, 255, 255);
 
 

 }

 function render_legend() {

 }
 
 
 
 function set ($name, $value) {
 $this->{$name} = $value;
 }

 function error_check () {

 
 if (!is_array($this->data)) {
 $this->error = "data has wrong format.";
 }

 
 if ($this->nr_values <= 0) {
 $this->error = "Error nr_values($this->nr_values) <= 0";
 }

 
 if ($this->max_y <= $this->min_y) {
 $this->error = "Error max_y($this->max_y) <= min_y($this->min_y)";
 }

 
 if ($this->x_size <= 0) {
 $this->x_size = 100;
 $this->error = "Error xsize <= 0";
 }
 
 
 if ($this->y_size <= 0) {
 $this->y_size = 20;
 $this->error = "Error ysize <= 0";
 }

 
 if ($this->x_left_margin < 0) {
 $this->error = "Error x_left_margin < 0";
 } else {
 $this->x_left_margin = floor($this->x_left_margin);
 }
 
 
 if ($this->x_right_margin < 0) {
 $this->error = "Error x_right_margin < 0";
 } else {
 $this->x_right_margin = floor($this->x_right_margin);
 }
 
 
 if ($this->y_top_margin < 0) {
 $this->error = "Error y_top_margin < 0";
 } else {
 $this->y_top_margin = floor($this->y_top_margin);
 }
 
 
 if ($this->y_bot_margin < 0) {
 $this->error = "Error y_bot_margin < 0";
 } else {
 $this->y_bot_margin = floor($this->y_bot_margin);
 }
 
 if (!(strlen($this->col_back) == 6 || strlen($this->col_back) == 7)) {
 $this->error = "Error col_back has wrong format";
 }

 if (!(strlen($this->col_grid) == 6 || strlen($this->col_grid) == 7)) {
 $this->error = "Error col_grid has wrong format";
 }

 if (!(strlen($this->col_major) == 6 || strlen($this->col_major) == 7)) {
 $this->error = "Error col_major has wrong format";
 }




 







 
 }

 
 function cc($color) {
 if ($color[0] == "#") $color = substr($color,1);
 $color=hexdec($color);
 $red=($color&0xFF0000)>>16;
 $green = ($color&0xFF00)>>8;
 $blue = ($color&0xFF);
 return array ($red, $green, $blue);
 }

 function display() {
 $this->error_check();
 $this->get_grid_data();
 if (!$this->graph) $this->init_image();
 $this->init_3D();
 $this->render();
 $this->render->finalize();
 
 header("Content-Type: image/png");
 ImagePng($this->graph);
 ImageDestroy($this->graph);
 
 }

 function render() {
 }

}
























 
 














































































































?>
