<?
node_include( "form_do_3" );
node_class("htmlformwizard");
GUIFactory::setMainGUI( "main" );


class DupSourcenameChecker
{
 var $m_key;
 var $m_self;

 function DupSourcenameChecker( $key, $self )
 {
 $this->m_key = $key;
 $this->m_self = $self;
 }

 function check( &$form )
 {
 $comp =& $form->getComponent( $this->m_key );
 $text = sqlslashes($comp->getText());
 if ( !$text )
 {
 $comp->addError( new NodeException( i18n( "You must specify a name!" ) ) );
 return;
 }
 $self = sqlslashes($this->m_self);
 $sql = "SELECT * FROM datasource WHERE name='".sqlf_escaped($text)."' AND name != '".sqlf_escaped($self)."'";
 $rs = query( $sql );
 
 if ( $rs["num"] > 0 )
 $comp->addError( new NodeException( i18n("A Datasource with this name already exists!") ) );
 }
}
$NODE_CLASS["dupsourcenamechecker"] = FALSE;

class SourceBuilder extends WizardBuilder
{
 var $m_type = -1;
 var $m_id = -1;
 var $m_doCreate = TRUE;
 var $m_source = FALSE;
 var $m_name = "";

 function SourceBuilder( $source_id )
 {
 if ( $source_id )
 {
 $source =& SourceFactory::load( $source_id );
 $this->m_source = &$source[key($source)];
 $this->m_name = key($source);
 $this->m_type = $this->m_source->getType();
 $this->m_id = $source_id;
 $this->m_source->setFirstStep( 2 );
 $this->m_doCreate = FALSE;
 }
 else
 {
 $this->m_doCreate = TRUE;
 }
 }
 
 function getSourceID()
 {
 return $this->m_id;
 }
 
 function getName() 
 {
 return $this->m_name;
 }
 
 function getSerializeKey()
 {
 $rs = array();
 $rs["parent"] = parent::getSerializeKey();
 $rs["type"] = $this->m_type;
 $rs["id"] = $this->m_id;
 $rs["docreate"] = $this->m_doCreate;
 $rs["source"] = node_serialize( $this->m_source );
 $rs["name"] = $this->m_name;
 return $rs;
 }
 
 function initFromSerializeKey( $rs )
 {
 parent::initFromSerializeKey( $rs["parent"] );
 $this->m_type = $rs["type"];
 $this->m_id = $rs["id"];
 $this->m_doCreate = $rs["docreate"];
 $this->m_source = node_unserialize( $rs["source"] );
 $this->m_name = $rs["name"];
 }
 
 function updateStep( &$wizard, $stepNr, &$form ) 
 {
 if ( $stepNr == 2 && $this->m_doCreate )
 {
 $s1 =& $wizard->getStep(1);
 $c =& $s1->getComponent( "type" );
 $type = $c->getSingleSelection();
 if ( $type != $this->m_type )
 {
 $form->clear();
 $source =& SourceFactory::getInstanceOf( $this->m_type );
 $source->setFirstStep( 2 );
 $source->createStep( $wizard, $stepNr, $form );
 $this->m_source =& $source;
 return;
 }
 }
 if ( $stepNr != 1 )
 $this->m_source->updateStep( $wizard, $stepNr, $form );
 }
 
 function createStep( &$wizard, $stepNr, &$form ) 
 {
 if ( $stepNr == 1 )
 {
 node_class( "selectcomponent" );
 $form->addComponent( "name", new TextComponent( i18n( "Name" ), TRUE, $this->m_name ) );
 $form->addComponent( "type", new SelectComponent( i18n( "Datasource Type" ),
 SourceFactory::getTypes(), ($this->m_type!=-1)?$this->m_type:FALSE ) );
 $form->addCustomCheck( new DupSourcenameChecker("name", $this->m_name) );
 }
 else
 {
 if ( $this->m_doCreate )
 {
 $s1 =& $wizard->getStep(1);
 $c =& $s1->getComponent( "type" );
 $this->m_type = $c->getSingleSelection();
 $source =& SourceFactory::getInstanceOf( $this->m_type );
 $source->setFirstStep( 2 );
 $this->m_source = &$source;
 }
 $this->m_source->createStep( $wizard, $stepNr, $form );
 }
 
 }
 
 function done( &$wizard )
 {
 global $REDO;
 $REDO = 19101;
 $this->m_source->done( &$wizard );
 
 $step1 = &$wizard->getStep( 1 );
 $o_name =&$step1->getComponent( "name" );
 $name = $o_name->getText();
 
 if ( !$this->m_doCreate )
 {
 $id = $this->m_id;
 }
 else
 $id = FALSE;
 SourceFactory::store( $this->m_source, $name, $id );
 }
 
 function cancel( &$wizard )
 {
 global $REDO;
 $REDO = 19101;
 if ( $this->m_source )
 $this->m_source->cancel( $wizard );
 }

 function getAdditionalButtons() {
 return array("done"=>array(array("key"=>"sync", "name"=>i18n("Synchronize"))));
 }

 function handleButton( &$wizard, $btnType, $btnKey ) {
 triggerEvent(T_SOURCE, $this->m_id, EVENT_NOTIFY, new EventObject(array('doSync'=>1)));
 return true;
 }
}


$NODE_CLASS["sourcebuilder"] = FALSE;
$NODEMENU[$DO]["add_info"] = i18n( "Edit Datasource" );

$form = new HtmlFormWizard( "mywizard" );
if ( $form->isNew() )
{
 $sourceBuilder = new SourceBuilder($source_id);
 $form->setBuilder( $sourceBuilder );
 $form->setHeader( $source_id?i18n("Edit Datasource ({0})",0,$sourceBuilder->getName()):i18n("Create Datasource"), $ICO_SOURCE );
}
else 
{
 $builder = &$form->getBuilder();
 
 $source_id = $builder->getSourceID();
}

if ( $source_id )
 $NODEMENU[$DO]["o_id"] = $source_id;

if ( $form->getStepId() === 2 ) {
 $ASSCORE .= i18n('Datasource sync help'); 
}

if ($source_id && $form->getStepId() == 1) {
 
 
 $select = "c.id, c.icon, c.keyword, d.value, d1.value description";
 $from = "construct c
	INNER JOIN part p ON p.construct_id = c.id
	INNER JOIN dicuser d ON c.name_id = d.output_id AND d.language_id = $LANGUAGE 
	INNER JOIN dicuser d1 ON c.description_id = d1.output_id AND d1.language_id = $LANGUAGE";
 $where = "p.type_id IN (29,30) AND p.info_int = $source_id";
 $ds = new SQLDatasource( "people", $select, $from, $where );
 $ds->setDBHandle( $DB );
 $ds->setDefaultSort("value","ASC");
 
 
 $ds->addColumn( "icon", '', true, "icon", "icon");
 $ds->addFormatter( "icon", new IconFormatter() );
 $ds->setColumnAttribs( "icon", 'width="1%"');
 
 $ds->addColumn( "value", i18n("Name"), true, false);
 $ds->makeLink("value","value", "do=10013&cmd=update", "list", "cid", "id");
 
 $ds->addColumn( "keyword", i18n('760.keyword'), true, false);
 
 $ds->addColumn( "description", i18n("description"), true, false);
 
 
 $list = new ItemList3("sources_usage",$ds);
 $list->setNoHeader(true);
}


class IconFormatter {
 function format( $row ) {
 return '&nbsp;<img src="?do=11&module=content&img=constr/' . $row["icon"] . '">' ;
 }
}
?>