<?php

node_include("core_file");





class FileUploader
{
 


 const INTERFACESTYLE_QUEUE = 0;
 const INTERFACESTYLE_SIMPLE = 1;

 




 private $interfaceStyle = INTERFACESTYLE_QUEUE;

 




 private $moduleBasePath;

 




 private $templatesBasePath;

 




 private $folderId = null;

 




 private $nodeId = null;

 





 private $fileId = null;

 





 private $fileInfo = null;

 





 private $multiFileEnabled = true;

 




 private $descriptionEnabled = true;

 




 private $uploadUrl = null;

 




 private $templatePath = null;

 




 private $fileUrlPrefix = null;

 




 private $folderListUrl = null;

 




 private $scriptFiles = array();

 




 private $stylesheetFiles = array();

 




 private $restMultiPartData = array();

 




 private $javascriptCallbacks = array(
 'onSuccess' => null,
 'onError' => null,
 'onFilesAdded' => null
 );

 




 private $htmlContainerId = 'fileuploader_container';

 




 private $htmlContainerIdPrefix = null;

 




 private $createFileUrl = null;

 





 private $saveFileUrl = null;

 




 private $fileFilters = array();

 




 private $isAutomaticUploadEnabled = true;

 




 private $isJavascriptInstanceExposed = false;



 





 public function __construct($folderId, $nodeId=null)
 {
 $this->setFolderId($folderId);
 $this->nodeId = $nodeId;

 
 $this->addRestMultiPartKeyValue('folderId', $folderId);
 $this->addRestMultiPartKeyValue('nodeId', $nodeId);

 
 $this->importGlobalGcnVariables();
 
 
 $this->setInterfaceStyle(INTERFACESTYLE_QUEUE);
 }

 




 public function importGlobalGcnVariables()
 {
 global $PORTLETAPP_PREFIX;
 $buildRootTimestamp = $GLOBALS['BUILD_ROOT_TIMESTAMP'];
 $this->moduleBasePath = $PORTLETAPP_PREFIX . $buildRootTimestamp;

 
 if ($buildRootTimestamp === "DEV") {
 
 $this->moduleBasePath .= "/ws/contentnode/contentnode-static/contentnode-static-fileuploader/src/main";
 
 
 $this->addScript('/js/vendor/plupload/js/plupload.full.js');
 $this->addScript('/js/vendor/plupload/js/jquery.plupload.queue/jquery.plupload.queue.js');
 $this->addScript('/js/fileuploader.js');
 } else {
 $this->moduleBasePath .= "/fileuploader";
 
 
 $this->addScript('/js/fileuploader-full.min.js');
 }
 
 
 
 if ($GLOBALS['LANGUAGE'] == 1) {
 $this->addScript('/js/plupload_i18n_de-fixed.js');
 }

 

 
 $this->addStylesheet('/js/vendor/plupload/js/jquery.plupload.queue/css/jquery.plupload.queue.css');
 
 $this->addStylesheet('/css/fileuploader.css');

 $this->templatesBasePath = $GLOBALS['NODEPATH'] . '/modules/' . $GLOBALS['MODULE'] . '/template/' . $GLOBALS['TPL'];
 
 $this->setFileUrlPrefix($GLOBALS['STAG'] . "&do=15000&cmd=update");
 $this->setFolderListUrl($GLOBALS['STAG'] . "&do=13020");
 
 $this->setMaxFilesize($GLOBALS['MAX_FILESIZE']);

 $portletappPrefix = $GLOBALS['PORTLETAPP_PREFIX'];

 $this->createFileUrl = $portletappPrefix . "rest/file/create.json";
 $this->saveFileUrl = $portletappPrefix . "rest/file/save/";
 $this->setUploadUrl($this->createFileUrl);

 
 $this->addRestMultiPartKeyValue('sid', $GLOBALS['SID']);
 }

 




 public function getPluploadBasePath()
 {
 return $this->moduleBasePath . '/js/vendor/plupload';
 }

 





 public function getFileId()
 {
 return $this->fileId;
 }

 


 public function setFileId($fileId)
 {
 $this->fileId = $fileId;

 if ($fileId === null) {
 $this->setUploadUrl($this->createFileUrl);
 } else {
 $this->setUploadUrl($this->saveFileUrl . $fileId);
 }
 }

 


 public function setFolderId($folderId)
 {
 $this->folderId = $folderId;
 $this->addRestMultiPartKeyValue('folderId', $folderId);
 }

 


 public function getMultiFileEnabled()
 {
 return $this->multiFileEnabled;
 }

 


 public function setMultiFileEnabled($multiFileEnabled)
 {
 $this->multiFileEnabled = $multiFileEnabled;
 }

 


 public function getDescriptionEnabled()
 {
 return $this->descriptionEnabled;
 }

 


 public function setDescriptionEnabled($descriptionEnabled)
 {
 $this->descriptionEnabled = $descriptionEnabled;
 }

 


 public function getJavascriptCallbacks()
 {
 return $this->javascriptCallbacks;
 }

 


 public function getJavascriptSuccessCallback()
 {
 if (empty($this->javascriptCallbacks['onSuccess'])) {
 $this->javascriptCallbacks['onSuccess'] = "null";
 }

 return $this->javascriptCallbacks['onSuccess'];
 }

 


 public function getJavascriptErrorCallback()
 {
 if (empty($this->javascriptCallbacks['onError'])) {
 $this->javascriptCallbacks['onError'] = "null";
 }

 return $this->javascriptCallbacks['onError'];
 }

 


 public function getJavascriptFilesAddedCallback()
 {
 if (empty($this->javascriptCallbacks['onFilesAdded'])) {
 $this->javascriptCallbacks['onFilesAdded'] = "null";
 }

 return $this->javascriptCallbacks['onFilesAdded'];
 }

 






 public function setJavascriptCallbacks($callbacks)
 {
 $this->javascriptCallbacks = $callbacks;
 }

 


 public function getScripts()
 {
 return $this->scriptFiles;
 }

 





 public function addScript($file)
 {
 $this->scriptFiles[] = $file;
 }
 public function getStylesheets()
 {
 return $this->stylesheetFiles;
 }

 





 public function addStylesheet($file)
 {
 $this->stylesheetFiles[] = $file;
 }

 




 public function setUploadUrl($url)
 {
 
 
 $this->uploadUrl = $url . "?filter-contenttype=text%2Fplain";
 }

 public function getFileUrlPrefix()
 {
 return $this->fileUrlPrefix;
 }

 




 public function setFileUrlPrefix($str)
 {
 $this->fileUrlPrefix = htmlentities($str);
 }

 


 public function getFolderListUrl()
 {
 return $this->folderListUrl;
 }

 




 public function setFolderListUrl($str)
 {
 $this->folderListUrl = htmlentities($str);
 }

 


 public function getUploadUrl()
 {
 return $this->uploadUrl;
 }

 


 public function getMaxFilesize()
 {
 return $this->maxFilesize;
 }

 




 public function setMaxFilesize($maxFilesize)
 {
 $this->maxFilesize = $maxFilesize;
 }

 





 public function addRestMultiPartKeyValue($key, $value)
 {
 $this->restMultiPartData[$key] = $value;
 }

 


 public function getRestMultiPartData()
 {
 return $this->restMultiPartData;
 }

 





 public function getFileInfo()
 {
 if ($this->fileInfo === null && $this->fileId !== null) {
 $this->fileInfo = get_fileinfo($this->fileId);
 }

 return $this->fileInfo;
 }

 


 public function getFileDescription()
 {
 $fileInfo = $this->getFileInfo();

 if ($fileInfo === null) {
 return null;
 }

 return $fileInfo['description'];
 }

 





 public function setInterfaceStyle($style)
 {
 $this->interfaceStyle = $style;

 switch ($style) {
 case INTERFACESTYLE_SIMPLE: {
 $this->templatePath = $this->templatesBasePath . '/fileuploader_simple.php';
 
 $this->setDescriptionEnabled(false);
 break;
 }
 default: {
 
 $this->templatePath = $this->templatesBasePath . '/fileuploader_queue.php';
 }
 }
 }

 


 public function getHtmlContainerIdPrefix()
 {
 return $this->htmlContainerIdPrefix;
 }

 


 public function setHtmlContainerIdPrefix($prefix)
 {
 $this->htmlContainerIdPrefix = $prefix;
 }

 


 public function getHtmlContainerId()
 {
 $prefix = $this->getHtmlContainerIdPrefix();
 if ($prefix === null) {
 return $this->htmlContainerId;
 }

 return $prefix . '_' . $this->htmlContainerId;
 }

 


 public function setHtmlContainerId($id)
 {
 $this->htmlContainerId = $id;
 }

 


 public function getFileFilters()
 {
 return $this->fileFilters;
 }

 









 public function addFileFilter($fileFilter)
 {
 $this->fileFilters[] = $fileFilter;
 }

 


 public function getAutomaticUploadEnabled()
 {
 return $this->isAutomaticUploadEnabled;
 }

 


 public function setAutomaticUploadEnabled($enabled)
 {
 $this->isAutomaticUploadEnabled = $enabled;
 }

 


 public function isJavascriptInstanceExposed()
 {
 return $this->isJavascriptInstanceExposed;
 }

 


 public function setJavascriptInstanceExposed($enabled)
 {
 $this->isJavascriptInstanceExposed = $enabled;
 }
 
 




 public function getAssetsHtml()
 {
 $output = "";

 $stylesheetFiles = $this->getStylesheets();
 foreach ($stylesheetFiles as $stylesheetFile) {
 $output .= '<link rel="stylesheet" href="' . $this->moduleBasePath . $stylesheetFile . '">' . "\n";
 }

 $scriptFiles = $this->getScripts();
 foreach ($scriptFiles as $scriptFile) {
 $output .= '<script type="text/javascript" src="' . $this->moduleBasePath . $scriptFile . '"></script>' . "\n";
 }

 return $output;
 }

 











 public function getHtml()
 {
 if ($this->fileId !== null) {
 
 $this->fileInfo = $this->getFileInfo();
 }

 
 $saveFileuploaderGlobal = null;
 if (isset($GLOBALS['fileUploader'])) {
 $saveFileuploaderGlobal = $GLOBALS['fileUploader'];
 }

 $GLOBALS['fileUploader'] = $this;
 $output = getIncludeContents($this->templatePath);

 
 $GLOBALS['fileUploader'] = $saveFileuploaderGlobal;

 return $output;
 }

 


 public function __toString()
 {
 return $this->getHtml();
 }
}
